﻿Worker worker = new Worker();
var tasks = new Task<int>[]
{
    DoSomeLocalWork(1000),
    worker.DoSomeWork(2000),
    worker.DoSomeOtherWork(3000),
};

var completedTask = await Task.WhenAny(tasks); //first task completes

Console.WriteLine($"{completedTask.MethodName()} finished first\n");

foreach (var task in tasks)
{
    try 
    {
        Console.WriteLine($"{task.MethodName()}. Id {task.Id}, result {await task}, status {task.Status}");
    }
    catch(OperationCanceledException ex)
    {
        Console.WriteLine($"{task.MethodName()}. Id {task.Id}, status {task.Status}, {ex.Message}");
    }
}

async Task<int> DoSomeLocalWork(int delayTime)
{
    await Task.Delay(delayTime);
    return delayTime;
}